function love.load()
	nx,ny = 40,30
	scaleX,scaleY = 10,10
	threshold = 0.5
	blocksize = 20
	colors = {
		{0,0,255},
		{0,255,0},
	}
	seed = 0

end

function love.draw()
	for i = 1,nx do
		for j = 1,ny do
			love.graphics.setColor(colors[blockType(i,j,scale,threshold,seed)])
			love.graphics.rectangle('fill',(i-1)*blocksize,(j-1)*blocksize,blocksize-1,blocksize-1)
		end
	end
	love.graphics.setColor(0,0,0,200)
	love.graphics.rectangle('fill',0,0,120,80)
	love.graphics.setColor(255,255,255)
	love.graphics.print('scaleX = ' .. scaleX,10,10)
	love.graphics.print('scaleY = ' .. scaleY,10,25)	
	love.graphics.print('threshold = ' .. threshold,10,40)
	love.graphics.print('seed = ' .. seed, 10,55)
end

function love.update(dt)
	if love.keyboard.isDown('up') then
		scaleY = scaleY + 10*dt
	end
	if love.keyboard.isDown('down') then
		scaleY = math.max(scaleY - 10*dt,0.1)
	end
	if love.keyboard.isDown('left') then
		scaleX = scaleX + 10*dt
	end
	if love.keyboard.isDown('right') then
		scaleX = math.max(scaleX - 10*dt,0.1)
	end	
	
	if love.keyboard.isDown('w') then
		threshold = math.min(threshold + dt,1)
	end
	if love.keyboard.isDown('s') then
		threshold = math.max(threshold - dt,0)
	end
	
	if love.keyboard.isDown('a') then
		seed = seed + dt
	end
	if love.keyboard.isDown('d') then
		seed = seed - dt
	end
end

function love.keypressed(key)
	if key == ' ' then
		scaleX = math.sqrt(scaleX*scaleY)
		scaleY = scaleX
	end
end

function blockType(i,j,scale,threshold,seed)
	local value = love.math.noise(i/scaleX,j/scaleY,seed)
	if value > threshold then
		return 1
	else
		return 2
	end
end
